#ifndef AUDIOCLIP_HH
#define AUDIOCLIP_HH

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cmath>


class Audio;
class MultiTrackArea;
class Track;

class AudioClip
        {
        public:
                AudioClip(Track* aParent, Audio *anAudioSource, long long aSourceFirstBlock, long long aLenght, long long aTrackInsertPos);
                ~AudioClip();
                int draw();
                int play();
                int split();
                void mute();
                void unmute();
                void set_mta_container(MultiTrackArea* mta);
                long long get_lenght();
                AudioClip* prev;
                AudioClip* next;
                Audio* get_audio_source();
                void set_track_first_block(long long newTrackFirstBlock);

//        private:
                Track* parentTrack;
                MultiTrackArea* parentMTA;
                Audio* audioSource;
                GdkDrawable* drawPane;
                GdkPixmap* storePane;
                long long sourceFirstBlock;
                long long sourceLastBlock;
                long long trackFirstBlock;
                long long trackLastBlock;
                long long lenght;
                bool isMuted;
                int blockSize;
                int channels;
                int rate;
                int bitDepth;
                int bytesPerSample;
                long maxSample;
        };

#include "Audio.hh"
#include "Track.hh"
#include "MultiTrackArea.hh"

#endif
