#ifndef PROTUX_DSP_HH
#define PROTUX_DSP_HH

#include <string>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <linux/soundcard.h>

#include "MustuxLib/MustuxLib.hh"

class Dsp : public MustuxEngine
        {
        public :
                Dsp();
                ~Dsp();

                int open_for_play();
                int open_for_rec();
                int set(int channels, int rate, int size);
                int set_format(int requested_format);
                int get_best_fragment_size();
                int play_fragment(void* fragment, int fragment_size);
                int rec_fragment (void* fragment, int fragment_size);
                int close();
                string get_supported_formats();

                static const int OSS = 1;
                static const int ALSA = 2;
                static const int MPEG = AFMT_MPEG;
                static const int MU_LAW = AFMT_MU_LAW;
                static const int A_LAW = AFMT_A_LAW;
                static const int IMA_ADPCM = AFMT_IMA_ADPCM;
                static const int U8 = AFMT_U8;
                static const int S16_LE = AFMT_S16_LE;
                static const int S16_BE = AFMT_S16_BE;
                static const int S16_NE =AFMT_S16_NE;
                static const int U16_LE = AFMT_U16_LE;
                static const int U16_BE = AFMT_U16_BE;

        private :
                int Id;
                string audioDevice;
                void *buffer;


        };

#endif



//eof

