#ifndef FILESELECTOR_HH
#define FILESELECTOR_HH

#include <gtk/gtk.h>
#include <string>
#include <cstdio>
#include <dirent.h>
#include "MustuxLib/MustuxLib.hh"

class Dsp;

class FileSelector : public MustuxWindow // THIS CLASS MUST BE RENAMED TO AUDIOFILESELECTOR BECAUSE IT IS SPECIFIC
                                         // TO SELECT AUDIO FILES
    {
    public :
        FileSelector();
        ~FileSelector();

        int build();
        int init();
        int finalize();
        int unbuild();
        string get();

    private:
        GtkWidget *wAutoPlayCheck;
        GtkWidget *wAutoInfoCheck;
        GtkWidget *wDirectories;
        GtkWidget *wFiles;
        GtkWidget *wFilenameEntry;
        GtkWidget *wPathEntry;
        GtkWidget *okButton;
        GtkWidget *cancelButton;
        GtkWidget *wInfoWindow;

        Dsp* dsp;
        FILE* file;
        string filename;
        string currpath;
        string filefilter;
        int playTimeTag;
        bool isAutoPlayOn;
        bool isAutoInfoOn;
        bool isPlaying;
        bool isFileSelected;
        char* audioFrag;
        int audioFragSize;
        int channels;
        int bitDepth;
        int type;
        int rate;

        int read_dirs();
        int read_files();
        void get_info();
        void change_dir(string newDir);
        void fill_files();
        void fill_dirs();
        int start_playing();
        int restart_playing();
        int stop_playing();


        // callbacks
        static int play_fragment(void* fragment);
        static int on_autoplay_toggled(GtkToggleButton *togglebutton, FileSelector* o);
        //static int on_autoinfo_toggled(GtkToggleButton *togglebutton, FileSelector* o);
        static int on_ok(GtkWidget* w, FileSelector *o);
        static int on_cancel(GtkWidget* w, FileSelector *o);
        static int on_file_selected(GtkCList *clist,  int row, int column,  GdkEventButton *event, FileSelector *o);
        static int on_dir_selected(GtkCList *clist,  int row, int column,  GdkEventButton *event, FileSelector *o);
        static int on_filename_entry_changed(GtkWidget* w, FileSelector* o);
        static int on_path_entry_changed(GtkWidget* w, FileSelector* o);
        static int on_path_entered(GtkWidget* w, FileSelector *o);
        static int match(const struct dirent *e);
        static int isdir(const struct dirent *e);
   };

#include "Dsp.hh"

#endif

//eof

