#ifndef LOCATOR_HH
#define LOCATOR_HH

#include "MustuxLib/MustuxLib.hh"

class Locator : public MustuxComponent
        {
        private :
                bool JOG_Active;
                bool shuttle_active;
                bool must_shuttle;
                int JOG_tag;
                int shuttle_tag;
                int shuttle_timetag;
                int shuttle_mode;
                int shuttle_amount;
                float shuttle_factor;
                int cursor_position;
                int cursor_width;
                int old_cursor_position;
                int old_cursor_width;
                long long peak_step;

        public :
                Locator(MustuxWindow *rootWindow);
                Locator(MustuxComponent *parentComponent);
                ~Locator();

                void init();
                void build(int height, int width, bool scalable);
                void locate(int x);
                void resize_cursor();
                void toggle_cursor();
                void update_cursor();
                void JOG_locator();
                void shuttle(int mode);
                void shuttle_scroll(int x);
                void shuttle_update();
                bool jog_is_active();
                bool shuttle_is_active();
        };

#endif
//eof

