/*****************************************************************************************************

PROTUX - THE FREE PROFESSIONAL AUDIO TOOLS FOR LINUX
AUTHOR : Luciano Giordana - giordana@canada.com

This software is distributed under the terms of the GNU General Public License
as specified in the COPYING file.

*****************************************************************************************************/

#include <cstring>
#include "MustuxLib/MustuxKernel.hh"
#include "MustuxLib/MustuxDebugger.hh"
#include "Main.hh"
#include "Interface.hh"


// FOR LATER include "GlobalSettings.hh"


int main (int argc, char *argv[])
        {
        PENTER;
        MustuxKernel::init(argc, argv);

        // FOR LATER ::GlobalSettings::reset_all();
        // FOR LATER ::GlobalSettings::show_all();

        bool keyboardRepetition = false;
        if (argc > 1)
                {
                for (int i=1; i<argc; i++)
                        {
                        if (strcmp(argv[i],"-k")==0)
                                keyboardRepetition = true;
                        if (strcmp(argv[i],"-nd")==0)
                                MustuxDebugger::set_debug_off();
                        }
                }

        MustuxKernel::set_kb_repeat(keyboardRepetition);
        Interface *interface = new Interface();
        interface->build();
        interface->init();
        PMESG("Initializing Protux...");
        interface->start_interaction();
        delete interface;
        MustuxKernel::set_kb_repeat(!keyboardRepetition);

        cout << endl << "THANK YOU FOR USING THIS VERY YOUNG VERSION OF PROTUX, AND WELCOME TO PHASE II." << endl;
        PEXIT;
        return 0;
        }




