#include "MustuxLib/MustuxLib.hh"
#include "MultiTrackPanel.hh"
#include <cstdio>



MultiTrackPanel::MultiTrackPanel(GtkWidget* aParentBox) : MustuxComponent(aParentBox)
        {
        PENTERCONS;
        PEXITCONS;
        }

MultiTrackPanel::~MultiTrackPanel()
        {
        PENTERDES;
        PEXITDES;
        }



int MultiTrackPanel::build(int aTotalTracks)
        {
        PENTER;
        MustuxComponent::build(MustuxComponent::VERTICAL, MustuxComponent::NOT_HOMOGENEOUS, MustuxComponent::NOT_RESIZEABLE, MustuxComponent::FILLABLE);

        if (totalTracks > MAX_TRACKS)
                {
                PERROR("Tried to allocate more than MAX_TRACKS (" << MAX_TRACKS << ") Allocating " << MAX_TRACKS << " track panels");
                totalTracks = MAX_TRACKS;
                }

        totalTracks = aTotalTracks;
        for (int i=0; i<totalTracks; i++)
                {
                trackPanel[i]=new TrackPanel(this);
                trackPanel[i]->build(80,100);
                }
        PEXIT;
        return 1;
        }




int MultiTrackPanel::init()
        {
        PENTER;
        MustuxComponent::init();
        for (int i=0; i<totalTracks; i++)
                {
                trackPanel[i]->init();
                trackPanel[i]->set_track_number(i);
                }
        PEXIT;
        return 1;
        }






//eof
