#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk_imlib.h>
#include <cstdio>
#include <string>
#include <iostream>
#include "MustuxAboutWindow.hh"
#include "MustuxDebugger.hh"


MustuxAboutWindow::MustuxAboutWindow():MustuxWindow()
    {
    PENTERCONS;
    PEXITCONS;
    }

MustuxAboutWindow::~MustuxAboutWindow()
    {
    PENTERDES;
    finalize();
    unbuild();
    PEXITDES;
    }

int MustuxAboutWindow::build(string imageFile)
    {
    MustuxWindow::build();
    GdkImlibImage *im;
    int width, height;

    PMESG("MustuxAbout splash image file = " << imageFile);

    gtk_widget_push_visual(gdk_imlib_get_visual());
    gtk_widget_push_colormap(gdk_imlib_get_colormap());


    im=gdk_imlib_load_image((char*) imageFile.c_str());
    if (im == NULL)
        {
        PERROR("Cannot open " << imageFile);
        return -1;
        }
    width = im->rgb_width;
    height = im->rgb_height;
    gdk_imlib_render(im, width, height);

    pixmap = gdk_imlib_move_image(im);
    alphamask = gdk_imlib_move_mask(im);
    logo = gtk_pixmap_new(pixmap, alphamask);
    gtk_widget_show (logo);
    gtk_box_pack_start (GTK_BOX (box), logo, false, false, 0);
    return 1;
    }

int MustuxAboutWindow::init()
    {
    MustuxWindow::init();
    //gtk_grab_add(window);
    //gtk_main();
    return 1;
    }

int MustuxAboutWindow::finalize()
    {
    //gtk_widget_hide(window);
    //gtk_grab_remove(window);
    //gtk_main_quit();
    MustuxWindow::finalize();
    return 1;
    }

int MustuxAboutWindow::unbuild()
    {
    //gtk_widget_hide(window);
    //gtk_widget_destroy(window);
    MustuxWindow::unbuild();
    return 1;
    }


// eof

