#ifndef MUSTUXABOUTWINDOW_HH
#define MUSTUXABOUTWINDOW_HH

#include <gtk/gtk.h>
#include <string>
#include "MustuxDialog.hh"

class MustuxComponent;
class MustuxPane;

/** A MustuxAboutWindow is a basic window with a logo on it
 *  This logo can be a image file (an jpg or a png, for example)
 */
class MustuxAboutWindow : public MustuxWindow
    {
    public:
        MustuxAboutWindow();
        ~MustuxAboutWindow();

        /** Build the About Window, its internal widgets, and a logo from a given image file
         */
        int build(string imageFile);
        
        /** Initialize the About Window and its internal properties
         */
        int init();
        
        /** Finalize the About Window and internal properties
         */
        int finalize();
        
        /** Unbuild internal Widgets in About Window and de-allocate the memory used
         */
        int unbuild();

    private:
        MustuxComponent* logoContainer;
        GtkWidget* logo;
        GdkPixmap *pixmap;
        GdkBitmap *alphamask;



    };


#include "MustuxComponent.hh"
#include "MustuxPane.hh"

#endif

