#include <iostream>
#include "MustuxDebugger.hh"
#include "MustuxColorManager.hh"

GtkWidget* widget;
GdkColormap* cmap;
GdkGC* GC[MAX_COLORS];
GdkColor* color[MAX_COLORS];


void MustuxColorManager::build(GtkWidget* parentWidget)
    {
    PENTER;
    cmap = gtk_widget_get_colormap(parentWidget);
    widget = parentWidget;
    for (int i=0; i< MAX_COLORS; i++)
        {
        GC[i] = gdk_gc_new(parentWidget->window);
        color[i] = new GdkColor();
        color[i]->red = 0; // All new colors start being black
        color[i]->green = 0;
        color[i]->blue = 0;
        color[i]->pixel = 0;
        gdk_color_alloc(cmap, color[i]);
        gdk_gc_set_foreground (GC[i], color[i]);
        }
    PEXIT;
    }


void MustuxColorManager::init()
    {
    PENTER;
	set_fg(BLACK, 0, 0, 0);
    set_fg(WHITE, 65535,65535,65535);
    set_fg(RED, 65535,0,0);
    set_fg(GREEN, 0,65535,0);
    set_fg(FOREGROUND_COLOR, 50000,50000,50000);
    set_fg(PLAYING_PEAK_COLOR, 1000,1000, 20000);
    set_fg(RECORDING_PEAK_COLOR, 20000,1000,1000);
    set_fg(EMPTY_AREA_COLOR, 15000,15000,15000);
    set_fg(TRACK_BACKGROUND_COLOR, 25000,26000,28000);
    set_fg(AUDIO_VIEWER_AXIS_COLOR, 15000,15000,15000);
    set_fg(NO_AUDIO_COLOR,0,0,0);
    set_fg(REGION_SELECT_SHADOW_COLOR, 45000,35000,35000);
    set_fg(RENDERED_FILTER_NODE_COLOR, 1000,30000,1000);
    set_fg(FROZEN_FILTER_NODE_COLOR, 1000,1000,30000);
    set_fg(BYPASSED_FILTER_NODE_COLOR, 5000,5000,5000);
    set_fg(CRITICAL_FILTER_NODE_COLOR, 55000,15000,15000);
    set_fg(LCD_BACKGROUND_COLOR,39000,42000,35000);
    set_fg(LCD_OFF_DOT_COLOR, 30000, 30000, 30000);
    set_fg(LCD_ON_DOT_COLOR, 5500,6000,6000);
    set_fg(LCD_CRITICAL_DOT_COLOR , 58000,10000,10000);
    set_fg(LCD_TEXT_COLOR,55000,60000,60000);
    set_fg(LCD_TEXT_BACKGROUND_COLOR, 2000,2000,2000);
    set_fg(LCD_TEXT_CRITICAL_COLOR, 58000,10000,10000);
    set_fg(LCD_SMALLTEXT_COLOR, 55000,45000,15000);
    set_fg(FILTER_TRACK_BACKGROUND_COLOR, 55000,53000,56000);
    set_fg(REGION_SKIP_COLOR, 0,0,0);
    set_fg(TAKE_MARKER_COLOR, 0,0,0);
    set_fg(SPECTROGRAM_COLOR, 0,0,0);
    set_fg(LOCATOR_BACKGROUND_COLOR, 55000,52000,45000);
    set_fg(LOCATOR_PEAK_COLOR, 15000,15000,15000);
    set_fg(LIGHT_COLOR, 62000,63000,65000);
    set_fg(DARK_COLOR, 1500,1500,1500);
    set_fg(CLIP_BACKGROUND_COLOR, 51500,59200,54000);
    PEXIT;
    }



void MustuxColorManager::set_fg(int colorindex, gushort r, gushort g, gushort b)
    {
    color[colorindex]->red = r;
    color[colorindex]->green = g;
    color[colorindex]->blue = b;
    color[colorindex]->pixel = (gulong)(r*65536 + g*256 + b);
    gdk_color_alloc(cmap, color[colorindex]);
    gdk_gc_set_foreground (GC[colorindex], color[colorindex]);
    }


void MustuxColorManager::set_bg(int colorindex, gushort r, gushort g, gushort b)
    {
    color[colorindex]->red = r;
    color[colorindex]->green = g;
    color[colorindex]->blue = b;
    color[colorindex]->pixel = (gulong)(r*65536 + g*256 + b);
    gdk_color_alloc(cmap, color[colorindex]);
    gdk_gc_set_background (GC[colorindex], color[colorindex]);
    }


GdkGC* MustuxColorManager::get_color(int colorindex)
    {
    return GC[colorindex];
    }



// eof

