#include "MustuxConfirmWindow.hh"
#include "MustuxDialog.hh"
#include "MustuxDebugger.hh"


MustuxConfirmWindow::MustuxConfirmWindow():MustuxDialog()
    {
    PENTERCONS;
    PEXITCONS;
    }

MustuxConfirmWindow::~MustuxConfirmWindow()
    {
    PENTERDES;
    PEXITDES;
    }


int MustuxConfirmWindow::build()
    {
    PENTER;
    MustuxDialog::build();
    //gtk_window_set_title (GTK_WINDOW (window), "Confirm Action");
    yesButton=okButton;
    //GTK_BUTTON(okButton)->label="YES";

    noButton = gtk_button_new_with_label("NO");
    gtk_widget_show(noButton);
    gtk_box_pack_start (GTK_BOX (wButtonsContainer), noButton, false, false, 0);
    gtk_widget_set_usize (noButton, MustuxDialog::DEFAULT_BUTTON_WIDTH, MustuxDialog::DEFAULT_BUTTON_HEIGHT);
    //gtk_container_set_border_width (GTK_CONTAINER (noButton), 3);

    answer = false;
    PEXIT;
    return 1;
    }


int MustuxConfirmWindow::init()
    {
    PENTER;
    MustuxDialog::init();
    gtk_signal_connect (GTK_OBJECT (yesButton), "clicked",  GTK_SIGNAL_FUNC (on_yes), this);
    gtk_signal_connect (GTK_OBJECT (noButton), "clicked",  GTK_SIGNAL_FUNC (on_no), this);
    PEXIT;
    return 1;
    }


int MustuxConfirmWindow::finalize()
    {
    PENTER;
    MustuxDialog::finalize();
    PEXIT;
    return 1;
    }


int MustuxConfirmWindow::unbuild()
    {
    PENTER;
    gtk_widget_destroy(noButton);
    MustuxDialog::unbuild();
    PEXIT;
    return 1;
    }


bool MustuxConfirmWindow::get_answer(string message)
    {
    build();
    set_message("Are you sure you want to quit ?");
    init();
    start_interaction();
    return answer;
    }




// callbacks

int MustuxConfirmWindow::on_yes(GtkWidget *w, MustuxConfirmWindow *c)
    {
    c->answer=true;
    c->finalize();
    c->unbuild();
    return 1;
    };


int MustuxConfirmWindow::on_no(GtkWidget *w, MustuxConfirmWindow *c)
    {
    c->answer=false;
    c->finalize();
    c->unbuild();
    return 1;
    };

//eof


