#include "MustuxDialog.hh"
#include "MustuxDebugger.hh"



MustuxDialog::MustuxDialog():MustuxWindow()
    {
    PENTERCONS;
    PEXITCONS;
    }


MustuxDialog::~MustuxDialog()
    {
    PENTERDES;
    PEXITDES;
    }


int MustuxDialog::build()
    {
    PENTER;
    MustuxWindow::build();
    label = gtk_label_new ((char*)"(EMPTY MESSAGE)");
    gtk_widget_show(label);
    gtk_box_pack_start (GTK_BOX (box), label, false, false, 0);
    gtk_widget_set_usize (label, DEFAULT_LABEL_WIDTH, DEFAULT_LABEL_HEIGHT);

    wButtonsContainer = gtk_hbox_new (true, 0);
    gtk_widget_show (wButtonsContainer);
    gtk_box_pack_start (GTK_BOX (box), wButtonsContainer, false, false, 0);

    okButton = gtk_button_new_with_label("OK");
    gtk_widget_show(okButton);
    gtk_box_pack_start (GTK_BOX (wButtonsContainer), okButton, false, false, 0);
    gtk_widget_set_usize (okButton, DEFAULT_BUTTON_WIDTH, DEFAULT_BUTTON_HEIGHT);
    //gtk_container_set_border_width (GTK_CONTAINER (okButton), 3); //!! CAUSES A CRASH!!!?!?!!!
    PEXIT;
    return 1;
    }


int MustuxDialog::init()
    {
    PENTER;
    MustuxWindow::init();
    gtk_signal_connect (GTK_OBJECT (okButton), "clicked", GTK_SIGNAL_FUNC (on_ok), this);
    PEXIT;
    return 1;
    }


int MustuxDialog::finalize()
    {
    PENTER;
    MustuxWindow::finalize();
    stop_interaction();
    PEXIT;
    return 1;
    }



int MustuxDialog::unbuild()
    {
    PENTER;
    MustuxWindow::unbuild();
    PEXIT;
    return 1;
    }


void MustuxDialog::set_message(string message)
    {
    PENTER;
    gtk_label_set_text(GTK_LABEL(label), (const char*) message.c_str());
    PEXIT;
    }


// callbacks

int MustuxDialog::on_ok(GtkWidget* w, MustuxDialog* o)
    {
    o->finalize();
    return 1;
    }

//eof

