#ifndef MUSTUXDIALOG_HH
#define MUSTUXDIALOG_HH

#include <gtk/gtk.h>
#include "MustuxWindow.hh"

/** MustuxDialog is a simple dialog with a "OK" button
 */
class MustuxDialog : public MustuxWindow
    {
    public:
        MustuxDialog();
        ~MustuxDialog();

        /** Build the dialog and its internal widgets
         */
        int build();
        
        /** Initialize dialog and attach events to internal callbacks
         */
        int init();
        
        /** Finalize dialog and dettach events from internal callbacks
         */
        int finalize();

        /** Unbuild the dialog and its internal widgets
         */        
        int unbuild();

        /** Set the dialog's message
         */
        void set_message(string message);

    protected:
        static const int DEFAULT_BUTTON_WIDTH = 80;
        static const int DEFAULT_BUTTON_HEIGHT = 30;
        static const int DEFAULT_LABEL_WIDTH = 300;
        static const int DEFAULT_LABEL_HEIGHT = 50;

		GtkWidget* wButtonsContainer;
        GtkWidget* okButton;
        GtkWidget *label;
        static int on_ok(GtkWidget* w, MustuxDialog* o);


    };


#endif


//

