#ifndef MUSTUXENGINE_HH
#define MUSTUXENGINE_HH


#include <string>

class MustuxInterface;
class MustuxLcd;

/** MustuxEngine is the base class for many Mustux engines.
 *  It holds a reference to a interface (that uses and control the engine) and
 *  a LCD (for output of messages from the engine)
 */
class MustuxEngine
        {
        public :
            /** Creates a generic engine
             */
            MustuxEngine();
            virtual ~MustuxEngine();

            /** Initializes the engine and pass its controll to an interface given
             */
            int init(MustuxInterface *anInterface);

            /**  break the control from outside and finalize the internal structures;
             */
            int finalize();

            /** Print a message in the engine's output (an LCD)
             */
            void print (string s, int line);

        protected:
            MustuxInterface *interface;
            MustuxLcd* output;
            void print();


        };

#include "MustuxInterface.hh"
#include "MustuxComponent.hh"

#endif
