#ifndef MUSTUXKERNEL_HH
#define MUSTUXKERNEL_HH






    #define ML_DECLARE_CALLBACK(callback_name) \
    		static int static_ ## callback_name(GtkWidget* widget, gpointer genericCaller); \
    		void callback_name();
            

    #define ML_DEFINE_CALLBACK( callback_name, className ) \
            int className::static_ ## callback_name (GtkWidget* widget, gpointer genericCaller) \
                { \
                className* caller = (className*) genericCaller; \
                caller->callback_name(); \
                return 1; \
                } \
            void className::callback_name() 

	#define ML_CONNECT_CALLBACK(widget, message, handler) \
		    gtk_signal_connect( GTK_OBJECT(widget), message, GTK_SIGNAL_FUNC(static_ ## handler), this);






/** This is a collection of core methods used for initialize
 *  an Mustux Application
 */
namespace MustuxKernel
        {
        /** Initialize the X Widgets Engine (GTK)
        */
        void init(int argc, char *argv[]);

        /** Set the keyboard repetition on/off
        */
        void set_kb_repeat(bool status);

        void flush_events();

        }

    
#endif


