#ifndef MUSTUXNOTEBOOK
#define MUSTUXNOTEBOOK

#include <gtk/gtk.h>
#include <string>

#include "MustuxComponent.hh"

class MustuxNoteBook : public MustuxComponent
	{
    public :
        MustuxNoteBook(MustuxComponent* parent);
        ~MustuxNoteBook();
        int build();
        int build(int fillDirection);
        int init();
        int finalize();
        int unbuild();
        int add_project();
        int get_curr_project_number();
        GtkWidget* get_current_project_container();

        void set_label(int projNumber, string slabel);
        void set_project(int i);


        static const int MAX_PROJECTS = 50;

    private:
        GtkWidget* wProjectsContainer;
        GtkWidget* project[MAX_PROJECTS];  // boxes
        int currProject;

        // callbacks
        static int on_switch_project(GtkNotebook *w, GtkNotebookPage *p, int pageNum, MustuxNoteBook* o);
        static int on_configure_projects_area(GtkWidget *w, GdkEventConfigure *e, MustuxNoteBook* o);


    };



#endif

