#include <string>
#include "Constants.hh"
#include "PrafSettingsWindow.hh"
// FOR LATER :#include "GlobalSettings.hh"
#include "AudioFormats.hh"

// o melhor esquema de dialogs esta aqui, imitar.

PrafSettingsWindow::PrafSettingsWindow()
	{
	PENTER("");
	GtkWidget *vbox1, *vbox6, *vbox7, *vbox8;
	GtkWidget *hbox1, *hbox2, *hbox7, *hbox3, *hbox4, *hbox5, *hbuttonbox2;
	GtkWidget *label1, *label2, 	*label3, *label4, *label5, *label6;

	GtkWidget *scrolledwindow;	
	GtkWidget *infoframe, *descframe, *settingsframe;
	GtkWidget *combo1, *combo2, *combo3;	
	GList *combo1_items = NULL;	
	GList *combo2_items = NULL;
	GList *combo3_items = NULL;	
	GtkTooltips *tooltips;
	
	tooltips = gtk_tooltips_new ();
	
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), "New PRAF");
	gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
	
	vbox1 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox1);
	gtk_container_add (GTK_CONTAINER (window), vbox1);
	
	hbox1 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox1);
	gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);
	
	infoframe = gtk_frame_new ("Information");
	gtk_widget_show (infoframe);
	gtk_box_pack_start (GTK_BOX (hbox1), infoframe, FALSE, FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (infoframe), 10);
	
	vbox6 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox6);
	gtk_container_add (GTK_CONTAINER (infoframe), vbox6);
	
	hbox2 = gtk_hbox_new (TRUE, 0);
	gtk_widget_show (hbox2);
	gtk_box_pack_start (GTK_BOX (vbox6), hbox2, FALSE, FALSE, 0);
	
	label1 = gtk_label_new ("Project ");
	gtk_widget_show (label1);
	gtk_box_pack_start (GTK_BOX (hbox2), label1, FALSE, FALSE, 10);
	
	entry1 = gtk_entry_new();
	gtk_entry_set_max_length (GTK_ENTRY(entry1), 16);
	gtk_editable_set_editable(GTK_EDITABLE(entry1), true);		
	gtk_widget_show (entry1);
	gtk_box_pack_start (GTK_BOX (hbox2), entry1, FALSE, FALSE, 0);
	gtk_widget_set_usize (entry1, 125, -2);
	
	hbox3 = gtk_hbox_new (TRUE, 0);
	gtk_widget_show (hbox3);
	gtk_box_pack_start (GTK_BOX (vbox6), hbox3, FALSE, FALSE, 0);
	
	label2 = gtk_label_new ("Group");
	gtk_widget_show (label2);
	gtk_box_pack_start (GTK_BOX (hbox3), label2, FALSE, FALSE, 10);
	
	entry2 = gtk_entry_new();
	gtk_entry_set_max_length (GTK_ENTRY(entry2), 16);
	gtk_editable_set_editable(GTK_EDITABLE(entry2), true);		
	gtk_widget_show (entry2);
	gtk_box_pack_start (GTK_BOX (hbox3), entry2, FALSE, FALSE, 0);
	gtk_widget_set_usize (entry2, 125, -2);

	hbox4 = gtk_hbox_new (TRUE, 0);
	gtk_widget_show (hbox4);
	gtk_box_pack_start (GTK_BOX (vbox6), hbox4, FALSE, FALSE, 0);
	
	label3 = gtk_label_new ("Hardware");
	gtk_widget_show (label3);
	gtk_box_pack_start (GTK_BOX (hbox4), label3, FALSE, FALSE, 10);
	
	entry3 = gtk_entry_new();
	gtk_entry_set_max_length (GTK_ENTRY(entry3), 16);
	gtk_editable_set_editable(GTK_EDITABLE(entry3), true);		
	gtk_widget_show (entry3);
	gtk_box_pack_start (GTK_BOX (hbox4), entry3, FALSE, FALSE, 0);
	gtk_widget_set_usize (entry3, 125, -2);
	
	descframe = gtk_frame_new ("Description");
	gtk_widget_show (descframe);
	gtk_box_pack_start (GTK_BOX (hbox1), descframe, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (descframe), 10);
	
	scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow);
	gtk_container_add (GTK_CONTAINER (descframe), scrolledwindow);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), GTK_POLICY_NEVER, GTK_POLICY_NEVER);

	text_desc = gtk_text_new (NULL, NULL);
	gtk_editable_set_editable(GTK_EDITABLE(text_desc), true);		
	gtk_widget_show (text_desc);
	gtk_container_add (GTK_CONTAINER (scrolledwindow), text_desc);
	gtk_widget_set_usize (text_desc, -2, 20);
	gtk_tooltips_set_tip (tooltips, text_desc, "Enter important info here", NULL);
	gtk_text_set_editable (GTK_TEXT (text_desc), TRUE);
	
	settingsframe = gtk_frame_new ("Settings");
	gtk_widget_show (settingsframe);
	gtk_box_pack_start (GTK_BOX (vbox1), settingsframe, TRUE, TRUE, 10);
	gtk_container_set_border_width (GTK_CONTAINER (settingsframe), 10);
	
	hbox7 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox7);
	gtk_container_add (GTK_CONTAINER (settingsframe), hbox7);
	
	vbox7 = gtk_vbox_new (TRUE, 0);
	gtk_widget_show (vbox7);
	gtk_box_pack_start (GTK_BOX (hbox7), vbox7, TRUE, FALSE, 0);
	
	label4 = gtk_label_new ("Number of Channels");
	gtk_widget_show (label4);
	gtk_box_pack_start (GTK_BOX (vbox7), label4, FALSE, FALSE, 0);

	label5 = gtk_label_new ("Rate");
	gtk_widget_show (label5);
	gtk_box_pack_start (GTK_BOX (vbox7), label5, FALSE, FALSE, 0);
	
	label6 = gtk_label_new ("Bit Depth");
	gtk_widget_show (label6);
	gtk_box_pack_start (GTK_BOX (vbox7), label6, FALSE, FALSE, 0);
	
	vbox8 = gtk_vbox_new (TRUE, 0);
	gtk_widget_show (vbox8);
	gtk_box_pack_start (GTK_BOX (hbox7), vbox8, TRUE, TRUE, 10);
	
	combo1 = gtk_combo_new ();
	gtk_widget_show (combo1);
	gtk_box_pack_start (GTK_BOX (vbox8), combo1, FALSE, FALSE, 0);
	combo1_items = g_list_append (combo1_items, (char*) "Mono");
	combo1_items = g_list_append (combo1_items, (char*) "Stereo");
	combo1_items = g_list_append (combo1_items, (char*) "3 Channels");
	combo1_items = g_list_append (combo1_items, (char*) "4 Channels");
	combo1_items = g_list_append (combo1_items, (char*) "5 Channels");
	combo1_items = g_list_append (combo1_items, (char*) "6 Channels");
	combo1_items = g_list_append (combo1_items, (char*) "7 Channels");
	combo1_items = g_list_append (combo1_items, (char*) "8 Channels");
	gtk_combo_set_popdown_strings (GTK_COMBO (combo1), combo1_items);
	g_list_free (combo1_items);
	
	combo_entry1 = GTK_COMBO (combo1)->entry;
	gtk_widget_show (combo_entry1);
	gtk_entry_set_text (GTK_ENTRY (combo_entry1), "Stereo");
	
	combo2 = gtk_combo_new ();
	gtk_widget_show (combo2);
	gtk_box_pack_start (GTK_BOX (vbox8), combo2, FALSE, FALSE, 0);
	combo2_items = g_list_append (combo2_items, (char*) "22055 Hz - Internet Quality");
	combo2_items = g_list_append (combo2_items, (char*) "44100 Hz - CD Quality");
	combo2_items = g_list_append (combo2_items, (char*) "48000 Hz - DAT Quality");
	combo2_items = g_list_append (combo2_items, (char*) "96000 Hz - Studio Quality");
	gtk_combo_set_popdown_strings (GTK_COMBO (combo2), combo2_items);
	g_list_free (combo2_items);
	
	combo_entry2 = GTK_COMBO (combo2)->entry;
	gtk_widget_show (combo_entry2);
	gtk_entry_set_text (GTK_ENTRY (combo_entry2), "44100 Hz - CD Quality");
	
	combo3 = gtk_combo_new ();
	gtk_widget_show (combo3);
	gtk_box_pack_start (GTK_BOX (vbox8), combo3, FALSE, FALSE, 0);
	combo3_items = g_list_append (combo3_items, (char*) "16 bits - CD Quality");
	combo3_items = g_list_append (combo3_items, (char*) "20 Bits - Semi-professional Quality");
	combo3_items = g_list_append (combo3_items, (char*) "24 Bits - Professional Quality");
	gtk_combo_set_popdown_strings (GTK_COMBO (combo3), combo3_items);
	g_list_free (combo3_items);
	
	combo_entry3 = GTK_COMBO (combo3)->entry;
	gtk_widget_show (combo_entry3);
	gtk_entry_set_text (GTK_ENTRY (combo_entry3), "16 bits - CD Quality");
	
	hbox5 = gtk_hbox_new (TRUE, 0);
	gtk_widget_show (hbox5);
	gtk_box_pack_start (GTK_BOX (vbox1), hbox5, TRUE, TRUE, 0);
	
	hbuttonbox2 = gtk_hbutton_box_new ();
	gtk_widget_show (hbuttonbox2);
	gtk_box_pack_start (GTK_BOX (hbox5), hbuttonbox2, FALSE, FALSE, 0);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox2), GTK_BUTTONBOX_END);
	
	ok_button = gtk_button_new_with_label ("OK");
	gtk_widget_show (ok_button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox2), ok_button);
	GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);
	
	cancel_button = gtk_button_new_with_label ("Cancel");
	gtk_widget_show (cancel_button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox2), cancel_button);
	GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);

	project_label = "";
	group_label = "";
	hardware_label = "";
	description_label = "";
	nchannels = 2;
	rate = 44100;
	bit_depth = 16;
	PEXIT("");
	}


PrafSettingsWindow::~PrafSettingsWindow()
	{
	PENTER("- destructor");
	gtk_widget_destroy(window);
	PEXIT(" - destructor");
	}

static void _ok(GtkButton *w, PrafSettingsWindow* o)
	{
	o->ok();
	}

static void _cancel(GtkButton *w, PrafSettingsWindow* o)
	{
	o->cancel();
	}

void PrafSettingsWindow::show()
	{
	PENTER("");
	gtk_widget_show_all(window);
	gtk_signal_connect (GTK_OBJECT (ok_button), "clicked", GTK_SIGNAL_FUNC (_ok), this);
	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked", GTK_SIGNAL_FUNC (_cancel), this);
	gtk_signal_connect (GTK_OBJECT (window), "delete_event", GTK_SIGNAL_FUNC (_cancel), this);
	PEXIT("");
	}



bool PrafSettingsWindow::get()
	{
	PENTER("");
	gtk_main();	
	PEXIT("");
	return !cancelled;
	}		


void PrafSettingsWindow::ok()
	{
	cancelled = false;
	end_loop();
	}
	

void PrafSettingsWindow::cancel()
	{
	cancelled = true;
	end_loop();
	}


void PrafSettingsWindow::hide()
	{
	gtk_widget_hide_all(window);
	}




string PrafSettingsWindow::get_project_label()
	{
	return string(gtk_entry_get_text(GTK_ENTRY(entry1)));
	}

string PrafSettingsWindow::get_group_label()
	{
	return string(gtk_entry_get_text(GTK_ENTRY(entry2)));
	}

string PrafSettingsWindow::get_hardware_label()
	{
	return string(gtk_entry_get_text(GTK_ENTRY(entry3)));
	}

string PrafSettingsWindow::get_description_label()
	{
	char *t = gtk_editable_get_chars (GTK_EDITABLE(text_desc),0,-1);
	return string(t);
	}

int PrafSettingsWindow::get_rate()
	{
	return rate;	
	}
	
int PrafSettingsWindow::get_nchannels()
	{
	return nchannels;	
	}

int PrafSettingsWindow::get_bit_depth()
	{
	return bit_depth;
	}
