#ifndef TRACK_HH
#define TRACK_HH

#include <string>
#include "MustuxLib/MustuxLib.hh"

class Audio;
class AudioClip;
class MultiTrackArea;
class Mixer;

class Track
        {
        public :
                Track(MultiTrackArea* aParentMTA, int aBaseX, int aBaseY, int aWidth, int aHeight);
                ~Track();

                void recreate();
                void activate();
                void deactivate();
                void draw_axis();
                void clear();

                int play(long long startpoint);
                int stop();
                int draw();
                int fill(long long insertBlock, Audio* audio);

                int add_clip(Audio* audioSource, long long insertBlock, long long sourceFirstblock, long long lenght);
                int delete_clip(AudioClip* clip);
                int split_clip(long long splitPoint);

                AudioClip* get_clip_under(long long blockPos);
                AudioClip* get_next_clip_after(long long blockPos);

                bool is_pointed();



        // private :
                int ID;
                string name;
                MultiTrackArea* parentMTA;
                AudioClip* clipList;

                int baseX;
                int baseY;
                int width;
                int height;
                int masterGain;
                int masterPan;
                int masterMute;
                bool isActive;
                friend class MultiTrackArea;
                friend class Mixer;
        };

#include "Audio.hh"
#include "MultiTrackArea.hh"
#include "Mixer.hh"

#endif



