#include "MustuxLib/MustuxLib.hh"

#include "TrackPanel.hh"


TrackPanel::TrackPanel(MustuxComponent* aParent) : MustuxPane(aParent)
        {
        }

TrackPanel::~TrackPanel()
        {
        }



int TrackPanel::build(int w, int h)
        {
        PENTER;
        MustuxPane::build(w,h);
        PEXIT;
        return 1;
        }


int TrackPanel::init()
        {
        PENTER;
        MustuxPane::init();
        PEXIT;
        return 1;
        }


void TrackPanel::recreate()
        {
        PFLOODENTER;
        clear();
        char s[10]; s[9]=0;
        sprintf(s,"Track %1u" , trackNumber);
        draw_string(s,10, 10);
        PFLOODEXIT;
        }

void TrackPanel::clear()
        {
        PFLOODENTER;
        draw_rectangle(0, 0, get_width(), get_height(), true, MustuxColorManager::WHITE);
        PFLOODEXIT;
        }


void TrackPanel::activate()
        {
        PFLOODENTER;
        draw_rectangle( 0 , 0 , get_width()-1 , get_height()-1 , false, MustuxColorManager::RED);
        PFLOODEXIT;
        }


void TrackPanel::deactivate()
        {
        PFLOODENTER;
        draw_rectangle( 0 , 0 , get_width()-1 , get_height()-1 , false, MustuxColorManager::WHITE);
        PFLOODEXIT;
        }

void TrackPanel::set_track_number(int i)
        {
        PFLOODENTER;
        trackNumber = i;
        PFLOODEXIT;
        }
// eof

