#ifndef PROTUX_VU_HH
#define PROTUX_VU_HH

#include "Lcd.hh"
#include "Audio.hh"

class VUMeter : public Lcd
	{
	private :
		short sampleL;
		short sampleR;
		int refresh_rate;
		bool active;
		bool updating;
		int update_tag;
		Audio* audio_source;
		short old_sampleL;
		short old_sampleR;
	public :
		VUMeter(GtkWidget* box_to_place, int w, int h, bool scalable) : Lcd( box_to_place, w , h, scalable)
			{
			}
		~VUMeter()
			{
			}
		void start();
		void recreate();
		void reconfigure();
		void draw_grids();
		void set_audio_source(Audio* as);
		void activate();
		void deactivate();
		void start_updating();
		void stop_updating();
		void refresh_VU();
	};
	
#endif

	

// eof


