#include "WavFile.hh"
#include "MustuxLib/MustuxDebugger.hh"

WavFile::WavFile()
    {
    }

WavFile::~WavFile()
    {
    }

int WavFile::open(string newFileName)
    {
    fileName=newFileName;
    file = fopen(fileName.c_str(),"r");
    if (!file)
        return -1;
    read_header();
    return 1;
    }


int WavFile::create(string newFileName)
    {
    fileName=newFileName;
    file = fopen(fileName.c_str(),"w+");
    if (!file)
        return -1;
    write_header(2,44100,16);
    return 1;
    }


int WavFile::read_header()
    {
    rewind();
    fread(&(audioType), 4, 1 , file);
    fread(&(fileSize), sizeof(long), 1 , file);
    fileSize += 8;
    fread(&(riffType), 4, 1 , file);
    if (strncmp(audioType,"RIFF",4)!=0)
        {
        PERROR("File seems not to be a WAV/RIFF file");
        return -1;
        }
    fread(&(useLess),  8, 1 , file);
    fread(&(compressionCode), sizeof(short), 1, file);
    fread(&(channels), sizeof(short), 1 , file);
    fread(&(rate), sizeof(long), 1 , file);
    fread(&(bytesPerSec), sizeof(long), 1 ,file);
    fread(&(blockSize), sizeof(short), 1 , file);
    fread(&(bitDepth), sizeof(short), 1 , file);
    headerSize=64; /* common wav header size*/
    audioSize = fileSize - headerSize;
    return 1;
    }


int WavFile::write_header(int newChannels, int newRate, int NewBitDepth)
    {
    // TO DO : create a wav header
    return 1;
    }


void WavFile::rewind()
    {
    std::rewind(file);
    }


void WavFile::skip_header()
    {
    fseek(file, headerSize, SEEK_SET);
    }

FILE* WavFile::get_file()
    {
    return file;
    }

int WavFile::get_bit_depth()
    {
    return bitDepth;
    }


int WavFile::get_header_size()
    {
    return headerSize;
    }

long long WavFile::get_audio_size()
    {
    return audioSize;
    }

int WavFile::get_rate()
    {
    return rate;
    }

int WavFile::get_channels()
    {
    return channels;
    }

void WavFile::show_info()
    {
    PMESG("File       : " << fileName);
    PMESG("Channels   : " << (channels == 1 ? "Mono" : "Stereo"));
    PMESG("Rate       : " << rate << " Hz");
    PMESG("bitDepth   : " << bitDepth << " bits");
    }


