#ifndef WAVFILE_HH
#define WAVFILE_HH

#include <string>
#include <cstdio>

class WavFile
    {
    public:
        WavFile();
        ~WavFile();

        int open(string newFileName);
        int create(string newFileName);
        int read_header();
        int write_header(int nchannels, int arate, int abitdepth);
        void show_info();
        void rewind();
        void skip_header();
        FILE* get_file();
        int get_header_size();
        long long get_audio_size();
        int get_channels();
        int get_rate();
        int get_bit_depth();


    private:
        FILE* file;
        string fileName;
        char audioType[4];
        long fileSize;
        char riffType[4];
        char useLess[8];
        short compressionCode;
        short channels;
        long rate;
        long  bytesPerSec;
        short blockSize;
        short bitDepth;
        int headerSize;
        long long audioSize;

    };

#endif


